// Package sys
// @Link  https://github.com/bufanyun/hotgo
// @Copyright  Copyright (c) 2025 HotGo CLI
// @Author  Ms <133814250@qq.com>
// @License  https://github.com/bufanyun/hotgo/blob/master/LICENSE
// @AutoGenerate Version 2.17.8
package sys

import (
	"context"
	"fmt"
	"hotgo/internal/dao"
	"hotgo/internal/library/contexts"
	"hotgo/internal/library/hgorm/handler"
	"hotgo/internal/model/entity"
	"hotgo/internal/model/input/form"
	"hotgo/internal/model/input/sysin"
	"hotgo/internal/service"
	"hotgo/utility/convert"
	"hotgo/utility/excel"

	"github.com/gogf/gf/v2/database/gdb"
	"github.com/gogf/gf/v2/errors/gerror"
	"github.com/gogf/gf/v2/frame/g"
	"github.com/gogf/gf/v2/os/gctx"
	"github.com/gogf/gf/v2/util/gconv"

	"hotgo/internal/library/dict"
	"hotgo/internal/model"
)

type sSysLessonCategory struct{}

func NewSysLessonCategory() *sSysLessonCategory {
	return &sSysLessonCategory{}
}

func init() {
	service.RegisterSysLessonCategory(NewSysLessonCategory())
	dict.RegisterFunc("lessonCategoryOption", "课程分类选项", service.SysLessonCategory().Option)
}

// Model 课程分类ORM模型
func (s *sSysLessonCategory) Model(ctx context.Context, option ...*handler.Option) *gdb.Model {
	return handler.Model(dao.LessonCategory.Ctx(ctx), option...)
}

// List 获取课程分类列表
func (s *sSysLessonCategory) List(ctx context.Context, in *sysin.LessonCategoryListInp) (list []*sysin.LessonCategoryListModel, totalCount int, err error) {
	mod := s.Model(ctx)

	// 字段过滤
	mod = mod.Fields(sysin.LessonCategoryListModel{})

	// 查询分类名
	if in.Name != "" {
		mod = mod.WhereLike(dao.LessonCategory.Columns().Name, in.Name)
	}

	// 分页
	mod = mod.Page(in.Page, in.PerPage)

	// 排序
	mod = mod.OrderDesc(dao.LessonCategory.Columns().Id)

	// 查询数据
	if err = mod.ScanAndCount(&list, &totalCount, false); err != nil {
		err = gerror.Wrap(err, "获取课程分类列表失败，请稍后重试！")
		return
	}
	return
}

// Export 导出课程分类
func (s *sSysLessonCategory) Export(ctx context.Context, in *sysin.LessonCategoryListInp) (err error) {
	list, totalCount, err := s.List(ctx, in)
	if err != nil {
		return
	}

	// 字段的排序是依据tags的字段顺序，如果你不想使用默认的排序方式，可以直接定义 tags = []string{"字段名称", "字段名称2", ...}
	tags, err := convert.GetEntityDescTags(sysin.LessonCategoryExportModel{})
	if err != nil {
		return
	}

	var (
		fileName  = "导出课程分类-" + gctx.CtxId(ctx)
		sheetName = fmt.Sprintf("索引条件共%v行,共%v页,当前导出是第%v页,本页共%v行", totalCount, form.CalPageCount(totalCount, in.PerPage), in.Page, len(list))
		exports   []sysin.LessonCategoryExportModel
	)

	if err = gconv.Scan(list, &exports); err != nil {
		return
	}

	err = excel.ExportByStructs(ctx, tags, exports, fileName, sheetName)
	return
}

// Edit 修改/新增课程分类
func (s *sSysLessonCategory) Edit(ctx context.Context, in *sysin.LessonCategoryEditInp) (err error) {
	return g.DB().Transaction(ctx, func(ctx context.Context, tx gdb.TX) (err error) {

		// 修改
		if in.Id > 0 {
			in.UpdatedBy = contexts.GetUserId(ctx)
			if _, err = s.Model(ctx).
				Fields(sysin.LessonCategoryUpdateFields{}).
				WherePri(in.Id).Data(in).Update(); err != nil {
				err = gerror.Wrap(err, "修改课程分类失败，请稍后重试！")
			}
			return
		}

		// 新增
		in.CreatedBy = contexts.GetUserId(ctx)
		if _, err = s.Model(ctx, &handler.Option{FilterAuth: false}).
			Fields(sysin.LessonCategoryInsertFields{}).
			Data(in).OmitEmptyData().Insert(); err != nil {
			err = gerror.Wrap(err, "新增课程分类失败，请稍后重试！")
		}
		return
	})
}

// Delete 删除课程分类
func (s *sSysLessonCategory) Delete(ctx context.Context, in *sysin.LessonCategoryDeleteInp) (err error) {

	if _, err = s.Model(ctx).WherePri(in.Id).Unscoped().Delete(); err != nil {
		err = gerror.Wrap(err, "删除课程分类失败，请稍后重试！")
		return
	}
	return
}

// View 获取课程分类指定信息
func (s *sSysLessonCategory) View(ctx context.Context, in *sysin.LessonCategoryViewInp) (res *sysin.LessonCategoryViewModel, err error) {
	if err = s.Model(ctx).WherePri(in.Id).Scan(&res); err != nil {
		err = gerror.Wrap(err, "获取课程分类信息，请稍后重试！")
		return
	}
	return
}

// Option 获取课程分类选项
func (s *sSysLessonCategory) Option(ctx context.Context) (opts []*model.Option, err error) {
	var models []*entity.LessonCategory
	if err = s.Model(ctx).Fields(dao.LessonCategory.Columns().Id, dao.LessonCategory.Columns().Name).
		OrderDesc(dao.LessonCategory.Columns().Id).Scan(&models); err != nil {
		err = gerror.Wrap(err, "获取课程分类选项失败！")
		return
	}

	opts = make([]*model.Option, len(models))
	for k, v := range models {
		opts[k] = dict.GenHashOption(v.Id, gconv.String(v.Name))
	}
	return
}